package com.as.workflow.contorller;

import java.util.HashMap;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.as.common.json.requestJSON;
import com.as.common.jwt.UserLoginToken;
import com.as.common.utils.UserRole;
import com.as.user.controller.userContorller;
import com.as.user.dao.Role;
import com.as.user.dao.UserData;
import com.as.workflow.dao.ViewWorkFlowEntity;
import com.as.workflow.dao.WorkFlowEntity;
import com.as.workflow.service.WorkFlowService;
import com.auth0.jwt.JWT;

import jakarta.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/workflow")
public class WorkFlowContorller {
	private static final Logger logger = LogManager.getLogger(userContorller.class);
	@Autowired
	WorkFlowService workFlowServiceImpl;
	@Autowired
	UserRole UserRole;
	@UserLoginToken
	@RequestMapping(value="/getAllList", method=RequestMethod.POST)
	public requestJSON<List<WorkFlowEntity>> getAllList(@RequestBody WorkFlowEntity data){
		requestJSON<List<WorkFlowEntity>> json = new requestJSON<List<WorkFlowEntity>>();
		try {
			json.setCode(200);
			json.setData(workFlowServiceImpl.findWorkFlowList(data));
			json.setMessage("成功");
		} catch (Exception e) {
			json.setCode(500);
			json.setMessage("错误" + e.toString());
			return json; 
		}
		
		
		return json; 
	}
	@UserLoginToken
	@RequestMapping(value="/getStatus", method=RequestMethod.POST)
	public requestJSON<List<HashMap<String,Object>>> getStatus(@RequestBody WorkFlowEntity data){

		requestJSON<List<HashMap<String,Object>>> json = new requestJSON<List<HashMap<String,Object>>>();
		try {
			
			json.setCode(200);
			json.setData(workFlowServiceImpl.getStatus(data));
			json.setMessage("成功");
			return json; 
		} catch (Exception e) {
			json.setCode(500);
			json.setMessage("错误" + e.toString());
			return json; 
		}
	
		
		
	}
	@UserLoginToken
	@RequestMapping(value="/getGroupByWorkOrderNo", method=RequestMethod.POST)
	public requestJSON<List<ViewWorkFlowEntity>> getGroupByWorkOrderNo(@RequestBody WorkFlowEntity data){
		System.out.println(data+"/////////////////////");
		requestJSON<List<ViewWorkFlowEntity>> json = new requestJSON<List<ViewWorkFlowEntity>>();
		try {
			Object object = workFlowServiceImpl.findViewToWokeList(data).get("data");
			json.setCode(200);
			json.setData((List<ViewWorkFlowEntity>)object);
			json.setCount((Long)workFlowServiceImpl.findViewToWokeList(data).get("count"));
			json.setMessage("成功");
		} catch (Exception e) {
			json.setCode(500);
			json.setMessage("错误" + e.toString());
			return json; 
		}
	
		
		return json; 
	}
	@UserLoginToken
	@RequestMapping(value="/addWorkFlow", method=RequestMethod.POST)
	public requestJSON<Integer> addWorkFlow(@RequestBody WorkFlowEntity data, HttpServletRequest request){
		String header = request.getHeader("Authorization");
		String userId = JWT.decode(header).getAudience().get(0);
		logger.info(userId);
		requestJSON<Integer> json = new requestJSON<Integer>();
		List<Role> roleList = UserRole.getRoleList(Integer.parseInt(userId));
		logger.info(roleList.toString()+"");
		try {
			json.setCode(200);
			json.setData(workFlowServiceImpl.addWorkFlow(data,roleList));
			json.setData(1);
			json.setMessage("新增成功");
			return null; 
		} catch (Exception e) {
			json.setCode(500);
			json.setMessage("错误" + e.toString());
			return null; 
		}
	
		
	}
	
}
